#include <stdio.h>
#include <string.h>

#include "d88.h"

//#define STRICT_CHECK

#define D88_HEADER_SIZE (0x20 + 4 * 164)	// D88wb_̃TCY
#define D88_NAME	(0)						// fBXN̈ʒu
#define D88_PROTECT	(0x1a)					// CgveNg̗L̈ʒu (0:Ȃ 1:)
#define D88_TYPE	(0x1b)					// fBXN̎ނ̈ʒu(00H:2D 10H:2DD 20H:2HD)
#define D88_SIZE	(0x1c)					// fBXÑTCŸʒu(DWORD)
#define D88_TRACK	(0x20)					// gbNf[^e[u̐擪̈ʒu

// dwordl擾
static int GetInt(unsigned char *_p)
{
	int ret;

	ret = (_p[3]<<24) + (_p[2]<<16) + (_p[1]<<8) + _p[0];

	return ret;
}

// wordl擾
static int GetShort(unsigned char *_p)
{
	int ret;

	ret = (_p[1]<<8) + _p[0];

	return ret;
}

// RXgN^
D88::D88()
{
	m_fp = NULL;

	m_minrec = 1;
	m_maxrec = 16;

	m_curdisk = -1;
	m_numdisk = 0;
	m_disktype = -1;

	m_diskname[16] = '\0';
}

// fXgN^
D88::~D88()
{
	if (m_fp) fclose(m_fp);
}

// D88t@C̏
bool D88::SetFile(char *_fname)
{
	// w肪ȂƂ́AI
	if (_fname == NULL)
	{
		fclose(m_fp);
		m_fp = NULL;
		m_numdisk = 0;
		m_curdisk = -1;
		m_disktype = -1;
		return true;
	}

	// D88t@CI[v(oCi[h/ǂݍ)
	m_fp = fopen(_fname, "rb");
	if (m_fp == NULL) return false;

	int offset = 0;

	// fBXN[v
	for (m_numdisk = 0; m_numdisk < MAX_DISK; m_numdisk++)
	{
		int size;
		// D88wb_̃m
		unsigned char header[D88_HEADER_SIZE];
		// fBXNԍƂ̃ItZbgʒui[
		m_disk_offset[m_numdisk] = offset;

		// efBXN̐擪փV[N
		fseek(m_fp, offset, SEEK_SET);
		size = fread(header, 1, D88_HEADER_SIZE, m_fp);
		// D88wb_̃TCYȉɂȂƂɒf
		if (size != D88_HEADER_SIZE) break;
		// D88wb_̈ʒuvZ
		offset += GetInt(&header[D88_SIZE]);
	}
	return true;
}

// ŏ/őZN^ԍZbg
void D88::SetRecordRange(int _min, int _max)
{
	m_minrec = _min;
	m_maxrec = _max;
}

// ݑI𒆂D88̃fBXNԂ
int D88::GetNumDisk() const
{
	return m_numdisk;
};

// ݑI𒆂D88̃fBXNԍԂ
int D88::GetCurrentDisk() const
{
	return m_curdisk;
};

// w肵fBXNԍ̃fBXNJ
bool D88::SelectDisk(int _diskno)
{
	unsigned char header[D88_HEADER_SIZE];

	// D88t@CJĂ邩?
	if (m_fp == NULL) return false;

	m_curdisk_offset = -1;

	m_curdisk = -1;
	m_disktype = -1;
	m_disksize = 0;
	m_diskname[0] = '\0';

	// w肵fBXNۂ̖葽ꍇ͒f
	if (_diskno > m_numdisk) return false;

	m_curdisk_offset = m_disk_offset[_diskno];

	// V[N
	fseek(m_fp, m_curdisk_offset, SEEK_SET);

	// D88wb_ǂݍ
	fread(header, 1, D88_HEADER_SIZE, m_fp);
	// egbÑItZbgʒu擾
	for (int trk = 0; trk<164; trk++)
	{
		m_trk[trk] = GetInt(&header[D88_TRACK + trk*4]);
	}

	// fBXN^Cv擾
	m_disktype = header[D88_TYPE];
	// fBXNTCY擾
	m_disksize = GetInt(&header[D88_SIZE]);
	// fBXNRs[
	strncpy(m_diskname, (char *)&header[D88_NAME], 16);

	return true;
}

// fBXNԂ
const char *D88::GetDiskName() const
{
	return m_diskname;
}

// fBXN^CvԂ
int D88::GetDiskType() const
{
	return m_disktype;
}

// ReadDATA1
// w肵1ZN^ǂݍ
int D88::ReadDATA1(int _trk, int _C, int _H, int _R, int _N, unsigned char *_buffer, int _size)
{
	// t@CJĂȂꍇ͖߂
	if (m_fp == NULL) return 0;

	// gbNw肪Ƃ͖߂
	if (_trk >= 164 || m_trk[_trk] == 0 || m_trk[_trk] > m_disksize) return 0;

	// t@CV[N
	fseek(m_fp, m_curdisk_offset + m_trk[_trk], SEEK_SET);

	// ZN^[v
	for (int sec = 0;; sec++)
	{
		unsigned char header[16];

		// IDǂݎ
		fread(header, 1, 16, m_fp);

#ifdef STRICT_CHECK
		for (int i = 0x09; i <= 0x0e; i++)
		{
			if (header[i] != 0) return 0;
		}
#endif

		int C = header[0];
		int H = header[1];
		int R = header[2];
		int N = header[3];
		int maxsec = GetShort(&header[0x04]);	// őZN^
		int size = GetShort(&header[0x0e]);		// ZN^TCY

		// ЂƂZN^Ȃꍇ
		if (maxsec == 0) break;

		// w肵ZN^Ƃ
		if (C == _C && H == _H && R == _R && N == _N)
		{
		 	// ۂ̃ZN^w肳ꂽTCY傫ꍇ́Aw肳ꂽTCY܂œǂݍ
			if (size > _size) size = _size;

			// fBXNC[Wǂݍ
			fread(_buffer, 1, size, m_fp);
			// ۂɓǂݍ񂾃TCYԂĂ
			return size;
		}
		else
		{
			// ̃ZN^փV[Np
			fseek(m_fp, size, SEEK_CUR);
		}
		// ȏZN^ȂƂ͒f
		if (sec == maxsec - 1) break;
	}
	return 0;
}

// Read DATA
// fBXNC[W̓ǂݍ
int D88::ReadDATA(int _trk, int _C, int _H, int _R, int _N, unsigned char *_buffer, int _size)
{
	int trk = _trk;		// gbNԍ
	int C = _C;			// C
	int H = _H;			// H
	int R = _R;			// R
	int N = _N;			// N
	unsigned char *buffer = _buffer;	// ΂ӂ
	int size = 0;		// ۂɓǂݍ߂TCY

	// ZN^TCYN̒lvZ (N=1̂Ƃ256)
	int secsize = 0x80 << _N;
	int r;

	// w肵TCYǂނ܂ŌJԂ
	while (size < _size)
	{
		// Ō̒[̓ǂݍރoCgvZ
		if (secsize > _size - size) secsize = _size - size;
		// 1ZN^ǂݍ
		r = ReadDATA1(trk, C, H, R, N, buffer, secsize);
		// Ō̒[܂œǂݍ݂AۂɓǂݎTCYԂĂ
		if (r < secsize) return size;

		// obt@̈ʒuXV
		buffer += secsize;
		// ۂɓǂݍ񂾃TCYXV
		size += secsize;

		// ̃ZN^ZN^zĂꍇ
		if (R == m_maxrec)
		{
			trk++;			// ̃gbN
			if (H == 0)
			{
				H = 1;		// ʂ
			}
			else
			{
				H = 0;		// \ʂɂC̒l+1
				C++;
			}
			R = m_minrec;	// Rŏ̃ZN^ԍɂ킹
		}
		else
		{
			R++;			// ̃ZN^
		}
	}
	// ǂݍ񂾃TCYԂĂ
	return size;
}

// Read ID
// wgbNIDSēǂݍ
int D88::ReadID(int _trk, unsigned char *_buffer, int _size)
{
	// t@CJĂȂꍇ͖߂
	if (m_fp == NULL) return 0;

	// gbNw肪Ƃ͖߂
	if (_trk >= 164 || m_trk[_trk] == 0 || m_trk[_trk] > m_disksize) return 0;

	// fBXÑV[N
	fseek(m_fp, m_curdisk_offset + m_trk[_trk], SEEK_SET);

	int ret = 0;

	// wTCYɂȂ܂ŌJԂ
	for (int sec = 0; sec*4 < _size; sec++)
	{
		unsigned char header[16];

		// IDǂݎ
		fread(header, 1, 16, m_fp);

#ifdef STRICT_CHECK
		for (int i = 0x09; i <= 0x0e; i++)
		{
			if (header[i] != 0) return 0;
		}
#endif
		// ǂݎID擾
		int C = header[0];
		int H = header[1];
		int R = header[2];
		int N = header[3];
		int maxsec = GetShort(&header[0x04]);
		int size = GetShort(&header[0x0e]);

		// ꂼ̒lobt@ɏ
		_buffer[sec*4 + 0] = C;
		_buffer[sec*4 + 1] = H;
		_buffer[sec*4 + 2] = R;
		_buffer[sec*4 + 3] = N;

		// ǂݍ񂾃TCYJEg
		ret += 4;

		// ݈ʒu擾
		fseek(m_fp, size, SEEK_CUR);

		// ŏIZN^̏ꍇ̓[v𔲂
		if (sec == maxsec - 1)
		{
			break;
		}
	}
	// ǂݍ񂾃TCYԂĂ
	return ret;
}

